<html>
<head>
<title>Ogre::AtomicScalar&lt; T &gt; Class Template Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::AtomicScalar&lt; T &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__General.html">General</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::AtomicScalar" -->
<p><code>#include &lt;<a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>&gt;</code></p>

<p><a href="classOgre_1_1AtomicScalar-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#ab5c4f1a0732ba493f63d9f05b2064d39">AtomicScalar</a> (const T &amp;initial)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a7f7b1b54d293173d8f7b7351f4f9d148">AtomicScalar</a> (const <a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a>&lt; T &gt; &amp;cousin)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#aa928121fb83ba0746dda532079142191">AtomicScalar</a> ()</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#add12daab3ff51fa24089269ab93100a5">operator=</a> (const <a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a>&lt; T &gt; &amp;cousin)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a0760f71192ec2403e8928d69f27e8ff0">get</a> (void) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a18c86c571d84ca7daf21ff3e3265f886">set</a> (const T &amp;v)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a9efd49c8680f5e29cfb6da1de45da0e9">cas</a> (const T &amp;old, const T &amp;nu)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a0d3b3c126fd72016f63d2b70e206341d">operator++</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#ad570fbf9aa6ad3cc688ad7a572cfea1f">operator--</a> (void)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#ad45b625889810c679099fa85d7376cee">operator++</a> (int)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a3aeaef070ff26d2920cc0cd2e48b1b1c">operator--</a> (int)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a582c7e533ac3485ca23d206a259b2860">operator+=</a> (const T &amp;add)</td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="OgreThreadDefinesTBB_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> volatile T&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><h3>template&lt;class T&gt;<br/>
class Ogre::AtomicScalar&lt; T &gt;</h3>


<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00351">351</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>
</div><hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="ab5c4f1a0732ba493f63d9f05b2064d39"></a><!-- doxytag: member="Ogre::AtomicScalar::AtomicScalar" ref="ab5c4f1a0732ba493f63d9f05b2064d39" args="(const T &amp;initial)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::<a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a> </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>initial</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00355">355</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a7f7b1b54d293173d8f7b7351f4f9d148"></a><!-- doxytag: member="Ogre::AtomicScalar::AtomicScalar" ref="a7f7b1b54d293173d8f7b7351f4f9d148" args="(const AtomicScalar&lt; T &gt; &amp;cousin)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::<a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>cousin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00359">359</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="aa928121fb83ba0746dda532079142191"></a><!-- doxytag: member="Ogre::AtomicScalar::AtomicScalar" ref="aa928121fb83ba0746dda532079142191" args="()" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::<a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00363">363</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="a9efd49c8680f5e29cfb6da1de45da0e9"></a><!-- doxytag: member="Ogre::AtomicScalar::cas" ref="a9efd49c8680f5e29cfb6da1de45da0e9" args="(const T &amp;old, const T &amp;nu)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::<a class="el" href="classOgre_1_1AtomicScalar.html#a9efd49c8680f5e29cfb6da1de45da0e9">cas</a> </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>old</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>nu</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00386">386</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0760f71192ec2403e8928d69f27e8ff0"></a><!-- doxytag: member="Ogre::AtomicScalar::get" ref="a0760f71192ec2403e8928d69f27e8ff0" args="(void) const " -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::<a class="el" href="classOgre_1_1AtomicScalar.html#a0760f71192ec2403e8928d69f27e8ff0">get</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00372">372</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a0d3b3c126fd72016f63d2b70e206341d"></a><!-- doxytag: member="Ogre::AtomicScalar::operator++" ref="a0d3b3c126fd72016f63d2b70e206341d" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::operator++ </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00394">394</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad45b625889810c679099fa85d7376cee"></a><!-- doxytag: member="Ogre::AtomicScalar::operator++" ref="ad45b625889810c679099fa85d7376cee" args="(int)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::operator++ </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00406">406</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a582c7e533ac3485ca23d206a259b2860"></a><!-- doxytag: member="Ogre::AtomicScalar::operator+=" ref="a582c7e533ac3485ca23d206a259b2860" args="(const T &amp;add)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::operator+= </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>add</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00418">418</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad570fbf9aa6ad3cc688ad7a572cfea1f"></a><!-- doxytag: member="Ogre::AtomicScalar::operator&#45;&#45;" ref="ad570fbf9aa6ad3cc688ad7a572cfea1f" args="(void)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::operator-- </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00400">400</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3aeaef070ff26d2920cc0cd2e48b1b1c"></a><!-- doxytag: member="Ogre::AtomicScalar::operator&#45;&#45;" ref="a3aeaef070ff26d2920cc0cd2e48b1b1c" args="(int)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">T <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::operator-- </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00412">412</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="add12daab3ff51fa24089269ab93100a5"></a><!-- doxytag: member="Ogre::AtomicScalar::operator=" ref="add12daab3ff51fa24089269ab93100a5" args="(const AtomicScalar&lt; T &gt; &amp;cousin)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::operator= </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1AtomicScalar.html">AtomicScalar</a>&lt; T &gt; &amp;&#160;</td>
          <td class="paramname"><em>cousin</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00366">366</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<a class="anchor" id="a18c86c571d84ca7daf21ff3e3265f886"></a><!-- doxytag: member="Ogre::AtomicScalar::set" ref="a18c86c571d84ca7daf21ff3e3265f886" args="(const T &amp;v)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::<a class="el" href="structOgre_1_1set.html">set</a> </td>
          <td>(</td>
          <td class="paramtype">const T &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00380">380</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a0a91e280e9d28815a3e4e16fbd9cfb3c"></a><!-- doxytag: member="Ogre::AtomicScalar::mField" ref="a0a91e280e9d28815a3e4e16fbd9cfb3c" args="" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class T&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="OgreThreadDefinesTBB_8h.html#a18a523fad1f9e10324e1742865f562b7">OGRE_AUTO_MUTEX</a> volatile T <a class="el" href="classOgre_1_1AtomicScalar.html">Ogre::AtomicScalar</a>&lt; T &gt;::<a class="el" href="classOgre_1_1AtomicScalar.html#a0a91e280e9d28815a3e4e16fbd9cfb3c">mField</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAtomicWrappers_8h_source.html#l00429">429</a> of file <a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a>.</p>

<p>Referenced by <a class="el" href="OgreAtomicWrappers_8h_source.html#l00372">Ogre::AtomicScalar&lt; size_t &gt;::get()</a>, <a class="el" href="OgreAtomicWrappers_8h_source.html#l00394">Ogre::AtomicScalar&lt; size_t &gt;::operator++()</a>, <a class="el" href="OgreAtomicWrappers_8h_source.html#l00418">Ogre::AtomicScalar&lt; size_t &gt;::operator+=()</a>, and <a class="el" href="OgreAtomicWrappers_8h_source.html#l00400">Ogre::AtomicScalar&lt; size_t &gt;::operator--()</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreAtomicWrappers_8h_source.html">OgreAtomicWrappers.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:54
</p>
</body>
</html>
